(      Title:  Measured string storage
        File:  mstrings-store.fs
      Author:  David N. Williams
     License:  LGPL
     Version:  0.8.5
   Test file:  mstrings-test.fs
  Change log:  mstrings.log
     Revised:  October 21, 2010

Some of this file is derived from Wil Baden's Tool Belt, which
is in the public domain.  For the sake of the LGPL, any part of
this file not under another copyright is

Copyright [C] 2002, 2007, 2008, 2010 David N. Williams

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or at your option any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

If you take advantage of the option in the LGPL to put a
particular version of this library under the GPL, the author[s]
would regard it as polite if you would put any direct
modifications under the LGPL as well, and include a copy of this
request near the beginning of the modified library source.  A
"direct modification" is one that enhances or extends the
library in line with its original concept, as opposed to
developing a distinct application or library which might use it.

This is a library in the mstrings collection.  It is mostly ANS
Forth compatible up to case dependence, [UNDEFINED], and
REQUIRED.

The code is intended to be character clean.

Please see the file mstrings.html for terminology and more
detailed word specifications.
)
decimal

s" mstrings-cat.fs" required


\ *** M! WORDS
(
  <m!>  mroom?  m!
)

\ *** UTILITY WORDS

\ DEBUGGING
\ : .#  ( n -- )  cr ." #" . cr ;


\ *** DEFINITIONS

[UNDEFINED] <m!> [IF]  \ dstrings not loaded
: <m!>  ( s a-addr -- )
(
Store the fstring as an mstring at a-addr, without checking for
room.
)
  0 over ! <m+> ;
[THEN]

: mroom?  ( len mbuf /mbuf -- len mbuf flag )
(
The flag is the value of the predicate: c[len] + cell <= /mbuf
)
  2 pick /m u>= ; 

: m!  ( s mbuf /mbuf -- flag )
(
Store the fstring as an mstring with overflow checking.
)
  mroom? IF <m!> true ELSE 3drop false THEN ;
